set linesize 32000
set pagesize 1000
set echo on
set termout on
set trimspool on

spool insertnoappendnologging.log

-- look for log file switches

select * from v$log;

-- save current io func values

drop table iofuncbefore;

create table iofuncbefore as
select
FUNCTION_NAME,
SMALL_WRITE_MEGABYTES+LARGE_WRITE_MEGABYTES TOTAL_MEGABYTES
from
V$IOSTAT_FUNCTION
where
FUNCTION_NAME in ('Direct Writes', 'DBWR', 'LGWR');

-- do a bunch of insert append I/O

set timing on

drop table test1;
drop table test2;

-- create tables with nologging

create table test1 nologging as select * from dba_tables;
create table test2 nologging as select * from test1;

-- no append hints

insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;
insert  into test1 select * from test2;
commit;
insert  into test2 select * from test1;
commit;

-- report difference

select
after.function_name,
after.SMALL_WRITE_MEGABYTES+after.LARGE_WRITE_MEGABYTES-before.TOTAL_MEGABYTES WRITE_DIFF_MEGABYTES
from
V$IOSTAT_FUNCTION after,
iofuncbefore before
where
after.FUNCTION_NAME = before.function_name
order by WRITE_DIFF_MEGABYTES desc;

-- look for log file switches

select * from v$log;

spool off
